﻿import QtQuick 1.0
import "globals.js" as Globals

Rectangle {

    property double dPos1: 0
    property double dPos2: 0
    property double dPos3: 0
    property double dAngle: 0
    property string strText: ""

    id: bulletrectangle
    width: 246
    height: 34
    radius: 5

    gradient: Gradient {
        GradientStop {
            position: 0
            color: Globals.gBaseColor1
        }

        GradientStop {
            position: 0.49
            color: Globals.gBaseColor2
        }

        GradientStop {
            position: 0.99
            color: Globals.gBaseColor1
        }
    }
    opacity: 0.9
    rotation: 0
    smooth: true

    Text {
        id: text
        x: bulletrectangle.width/2 - width /2
        color: Globals.gTextColor
        text: strText
        style: Text.Outline
        styleColor: Globals.gOutLineColor;
        opacity: 1
        smooth: true
        font.bold: true
        font.pixelSize: 23

        /*
        id: text
        x: 1
        y: 0
        color: Globals.gTextColor
        text: strText
        anchors.rightMargin: 1
        anchors.bottomMargin: 0
        anchors.leftMargin: 1
        anchors.topMargin: 0
        style: Text.Outline
        anchors.fill: parent
        styleColor: Globals.gOutLineColor;
        opacity: 1
        horizontalAlignment: Text.AlignHCenter
        verticalAlignment: Text.AlignVCenter
        smooth: true
        font.bold: true
        font.pixelSize: 23
          */
    }

    states: [
        State {
            name: "state1"
            StateChangeScript {name: "myScript"; script: animation.start();}
        }
    ]

    SequentialAnimation
    {
        id: animation
        running: false
        ParallelAnimation
        {
            PropertyAnimation{ target: bulletrectangle; property: "opacity"; from: 0; to: 1; duration: 1500}
            NumberAnimation {target: bulletrectangle; property: "y"; easing.type: Easing.Linear; from: dPos1; to: dPos2; duration: 1500}
            NumberAnimation {target: bulletrectangle; property: "dAngle"; easing.type: Easing.Linear; from: 0; to: 360; duration: 1500}
        }

        PauseAnimation { duration: 5000 }

        ParallelAnimation
        {
            NumberAnimation {target: bulletrectangle; property: "y"; easing.type: Easing.Linear; from: dPos2; to: dPos3; duration: 800}
            NumberAnimation {target: bulletrectangle; property: "dAngle"; easing.type: Easing.Linear; from: 0; to: -360; duration: 800}
        }

        PropertyAnimation{ target: bulletrectangle; property: "opacity"; from: 1; to: 0; duration: 400}

        ScriptAction { script: bulletrectangle.state = ""; }
    }

    transform:
        Rotation
        {
            origin.x: width / 2;
            origin.y: height / 2;
            axis {x:1; y:0; z:0}
            angle: dAngle
        }
}
